<template>
  <div>
    <preview-image v-if="uploadAvailable" :preview-image="previewImage" />
    <v-file-input
      v-else
      v-model="inputImage"
      enctype="multipart/form-data"
      :label="textImage"
      filled
      prepend-icon="mdi-camera"
      class="input-file"
      type="file"
      accept="image/*"
      :rules="rules"
    />
  </div>
</template>

<script>
import PreviewImage from '~/components/register/previewImage';
export default {
  name: 'RegisterImage',
  components: { PreviewImage },
  props: {
    'uploadAvailable': {
      default: false,
      type: Boolean,
    },
    'textImage': {
      default: '',
      type: String,
    },
    'defaultImage': {
      default: '',
      type: String,
    },
  },
  data() {
    return {
      previewImage: this.defaultImage,
      rules: [
        value => !value || value.size < 2000000 || 'La imagen no puede ser mayor de 2 megas',
      ],
    };
  },
  computed: {
    inputImage: {
      get() {
        return null;
      },
      set(val) {
        const reader = new FileReader();
        // Use the javascript reader object to load the contents
        // of the file in the v-model prop
        reader.readAsDataURL(val);
        reader.onload = () => {
          this.previewImage = reader.result;
        };
        this.$emit('input', val);
        this.$emit('uploaded');
      },
    },
  },
  watch: {
    defaultImage() {
      this.previewImage = 'https://encrypted-tbn0.gstatic.com/images?q=tbn:ANd9GcTnyS5wftjqKAhXgo8yGXf9P8otWVYmfAOReLVwJ6wsko28QaIJUZFrjxuVNzot1vQhxFo&usqp=CAU';
    },
  },
};
</script>

<style scoped>
.input-file {
  width: 206px;
  height: 57px;
}
</style>
